#!/bin/bash

find /sys/block -name "sd*" -exec sh -c 'echo "cfq" > {}/queue/scheduler' \;

# General CFQ tunning to NCQ - 8 - 8 - 4
find /sys/block -name "sd*" -exec sh -c 'echo "0" > {}/queue/iosched/slice_idle' \;
find /sys/block -name "sd*" -exec sh -c 'echo "8" > {}/queue/iosched/group_idle' \;
find /sys/block -name "sd*" -exec sh -c 'echo "8" > {}/queue/iosched/quantum' \;

# CFQ tunning to Write/Read - 250 - 125 - 100 - 40 - 2
find /sys/block -name "sd*" -exec sh -c 'echo "250" > {}/queue/iosched/fifo_expire_async' \;
find /sys/block -name "sd*" -exec sh -c 'echo "125" > {}/queue/iosched/fifo_expire_sync' \;
find /sys/block -name "sd*" -exec sh -c 'echo "100" > {}/queue/iosched/slice_sync' \;
find /sys/block -name "sd*" -exec sh -c 'echo "40" > {}/queue/iosched/slice_async' \;
find /sys/block -name "sd*" -exec sh -c 'echo "10" > {}/queue/iosched/slice_async_rq' \;

# Fairness if enable - Pure Througput if disabled - 1 - 300
find /sys/block -name "sd*" -exec sh -c 'echo "1" > {}/queue/iosched/low_latency' \;
find /sys/block -name "sd*" -exec sh -c 'echo "300" > {}/queue/iosched/target_latency' \;

# CFQ tunning to Seeking Time - 2 - 16384
find /sys/block -name "sd*" -exec sh -c 'echo "2" > {}/queue/iosched/back_seek_penalty' \;
find /sys/block -name "sd*" -exec sh -c 'echo "16384" > {}/queue/iosched/back_seek_max' \;

# Generic Linux
find /sys/block -name "sd*" -exec sh -c 'echo "0" > {}/queue/rotational' \;
find /sys/block -name "sd*" -exec sh -c 'echo "0" > {}/queue/rq_affinity' \;
find /sys/block -name "sd*" -exec sh -c 'echo "512" > {}/queue/nr_requests' \;
find /sys/block -name "sd*" -exec sh -c 'echo "0" > {}/queue/nomerges' \;
find /sys/block -name "sd*" -exec sh -c 'echo "1" > {}/queue/add_random' \;

# Settra
find /sys/block -name "sd*" -exec sh -c 'echo "1536" > {}/queue/read_ahead_kb' \;

# Clean the cache
sync
